import pygame
import math


__author__="mg"
__date__ ="$May 27, 2013 1:01:03 PM$"

class BindBomb(pygame.sprite.Sprite):
    cooldown = 3.0
    def __init__(self,initial_position,soundStart,soundHit):
        pygame.sprite.Sprite.__init__(self)
        self.soundStart = soundStart
        self.soundHit = soundHit
        self.image = pygame.image.load("img/BindBomb.png").convert_alpha()
        self.rect = self.image.get_rect()
        self.rect.bottomleft = (initial_position[0]-self.image.get_width()/2, initial_position[1])
        self.speed = 400
        self.snareTime = 3.0
        self.damage = 100
        self.hitcount=0

        self.soundStart.play(0)

    # hit(Sprite Enemy, timestamp )
    # Funktion wird aufgerufen sobald das Projektil einen Gegner trifft. Dieser wird uebergeben
    # ret bool ob der Treffer den Gegner toetet
    def hit(self,enemy,timestamp):

        if(self not in enemy.hitBy):
            enemy.hitWith({self:timestamp})
            root = {"root":(timestamp, self.snareTime)}
            enemy.disable(root)
            self.hitcount += 1
            self.soundHit.play(0)
            return enemy.dealDamage(self.damage)


    def update(self,timestamp,time_passed):
        moved_distance = math.ceil(time_passed * self.speed)
        self.rect.top -= moved_distance
        if(self.hitcount >= 2):
            self.kill()
        if self.rect.top < 0:
            self.kill()

