import Block
from pygame import draw
import math
from math import *
import random

from BindBomb import *
from BombSprite import BombSprite
from EnemySprite import *
from LaserBomb import *
from MineBomb import *
from EnemyBomb import *
from PlayerSprite import *
from spriteanimation import *
import pygame
from pygame import *
import pygame.sprite
from Block import Block

__author__ = "mg"
__date__ = "June 19, 2013 12:54:51 PM$"


class Game():
    def __init__(self,fps):
        self.casterMinionDeathAnimationFrames = []

        #self.width and self.height of the window
        self.width = 600
        self.height = 500
        self.hudWidth = 600
        self.hudHeight = 100

        #self.fps
        self.fps = fps

        #game over flag
        self.gameover = False;

        self.enemySpeedIncrease = 5
        self.enemyHealthIncrease = 20

        #current cooldowns
        self.timeUsedQ = 0
        self.timeUsedW = 0
        self.timeUsedE = 0
        self.timeUsedR = 0


        #killcount
        self.kills = 0

        #clock
        self.clock = pygame.time.Clock()

        #init pygame
        pygame.init()

        #init screen
        self.screen = pygame.display.set_mode((self.width, self.height+self.hudHeight), 0, 32)
        pygame.display.set_caption("Lux Lazor Minion Invaders")

        self.hud = Surface((self.hudWidth,self.hudHeight))

        # cooldowns der skills
        self.cooldownQ=BindBomb.cooldown
        self.cooldownW=BombSprite.cooldown
        self.cooldownE=MineBomb.cooldown
        self.cooldownR=LaserBomb.cooldown
        
        # UI Fonts
        self.counterFont = pygame.font.SysFont("arial", 24)
        self.counterFont.set_bold(True);
        self.cdFont = pygame.font.SysFont("arial", 12)
        self.cdFont.set_bold(True);

        # UI Images
        self.bgImage = "img/rift.jpg"
        self.hudBg = pygame.image.load("img/hudBg.png")

        self.iconQ = pygame.image.load("img/BindBombIcon.png")
        self.iconW = pygame.image.load("img/BombSpriteIcon.png")
        self.iconE = pygame.image.load("img/MineBombIcon.png")
        self.iconR = pygame.image.load("img/LaserBombIcon.png")
        self.iconLives = Surface((180,30))

        self.iconQBW = pygame.image.load("img/BindBombIconBW.jpg")
        self.iconWBW = pygame.image.load("img/BombSpriteIconBW.jpg")
        self.iconEBW = pygame.image.load("img/MineBombIconBW.jpg")
        self.iconRBW = pygame.image.load("img/LaserBombIconBW.jpg")

        self.gameOverImage = pygame.image.load("img/gameover.png").convert_alpha()

        #sounds
        self.music = pygame.mixer.Sound("sound/bgMusic.ogg")
        self.music.play(0)
        self.soundE = pygame.mixer.Sound("sound/LuxSounds_e.ogg")
        self.soundEHit = pygame.mixer.Sound("sound/LuxSounds_e_pop.ogg")
        self.soundQ = pygame.mixer.Sound("sound/LuxSounds_q.ogg")
        self.soundQHit = pygame.mixer.Sound("sound/LuxSounds_q_hit.ogg")
        self.soundR = pygame.mixer.Sound("sound/LuxSounds_laser.ogg")
        self.soundW = pygame.mixer.Sound("sound/LuxSounds_aa.ogg")
        self.soundWHit = pygame.mixer.Sound("sound/LuxSounds_aa_hit.ogg")
        self.soundGameOver = pygame.mixer.Sound("sound/LuxSounds_gameover.ogg")

        #layer Sprite init
        self.player = PlayerSprite((self.width / 2 -32, self.height - 64), 150)
        self.direction = 0

        self.timeBonusSpawned = 0;
        #enemy first wave creation

        self.initGame()

        while True:
            self.loop()

    def initBlocks(self):
        self.blocks = pygame.sprite.Group()
        bs = Block.blockSize
        color = (151,188,235)
        template= [[1,1,1,1,1,1,1,1],
            [0,1,1,1,1,1,1,0],
            [0,0,1,1,1,1,0,0],
            [0,0,0,1,1,0,0,0],]
        blockPos = [(50,350), (self.width/2 - len(template[0])*bs/2,350),(self.width - len(template[0])*bs- 50,350)]

        for pos in blockPos:
            for y in range(len(template)):
                for x in range(len(template[0])):
                    if(template[y][x] == 1):
                        p = (pos[0]+ x*bs, pos[1]+y*bs)
                        self.blocks.add(Block(p,color))
        self.blocks.update()
        self.blocks.draw(self.screen)

    # initGame
    # initialisiert alle variablen des aktuellen runs
    # ret: void
    def initGame(self):
        self.player = PlayerSprite((self.width / 2 -32, self.height - 64), 150)

        self.gameover = False;
        self.soundGameOver.stop()
        # zeitpunkte der letzten aktivierung der skills
        self.timeUsedQ = 0
        self.timeUsedW = 0
        self.timeUsedE = 0
        self.timeUsedR = 0

        self.kills = 0

        self.enemyCount = (5,8)
        self.enemyInitialSpeed = 1
        self.enemyHealth = 100
        self.initBlocks()

        #GROUPS
        self.bodies = pygame.sprite.Group()
        self.enemies = pygame.sprite.Group()
        self.enemyBombs = pygame.sprite.Group()
        self.createEnemies(self.enemyCount[0],self.enemyCount[1], self.enemyInitialSpeed,self.enemyHealth);
        self.bombs = pygame.sprite.Group()
        self.playerG = pygame.sprite.GroupSingle()
        self.playerG.add(self.player)


    # CreateEnemies im durchlauf modus
    # Fuellt die Enemies-Group mit einer gegebenen anzahl Gegner mit gegebenem speed
    # param: count - Anzahl der Gegner
    # param: speed - Geschwindigkeit der Gegner
    # ret: void
    def createEnemies(self,rows,cols, speed,health):
        colors = ["","Yellow","Blue"]
        hpInc = [0,50,100]
        boundaries = Rect(0,0,self.width,self.height)
        offset = 64
        color = ""
        for row in range(rows):
            for col in range(cols):
                hp = health
                pos = (col*offset,row*offset)
                if(row <= len(colors)-1):
                    color = colors[len(colors)-1-row]
                    hp += hpInc[len(colors)-1-row]
                self.enemies.add(EnemySprite(pos,speed,hp,boundaries,color))
			
    # Kollionstest
    # Testet auf Kollision zweier Sprites. spriteA ist eine Bombe, spriteB ein gegner
    # ret: bool
    def testCollision(self,spriteA, spriteB):
        if pygame.sprite.collide_rect(spriteA, spriteB):
            # hit collision detected
            if type(spriteB) is PlayerSprite:
                spriteA.kill();
                spriteB.lives -= spriteA.damage
                return
            elif spriteB.hasCollision:
                score = spriteB.score
                if spriteA.hit(spriteB,pygame.time.get_ticks()):
                    self.kills += score

    # bombsContainType(<Bombtype>)
    # liefert eine liste der Bomben in der Bombengruppe mit gegebenem bombentyp (Klassenbezeichnung!)
    # ret: [BombsWithWantedType]
    def bombsContainType(self,searchBomb):
        ret = []
        for bomb in self.bombs.sprites():
            if(type(searchBomb) == type(bomb)):
                ret.append(bomb)
        return ret


    # showEnd
    # zeigt den Game Over screen
    # ret: void
    def showEnd(self):
        self.screen.blit(self.gameOverImage,(self.width /2 - self.gameOverImage.get_width()/2,self.height /2 - self.gameOverImage.get_height()/2))
        self.soundGameOver.play()
        self.stopSounds()

    def stopSounds(self):
        self.soundE.stop()
        self.soundEHit.stop()
        self.soundQ.stop()
        self.soundQHit.stop()
        self.soundR.stop()
        self.soundW.stop()
        self.soundWHit.stop()

    def drawHud(self):
        self.screen.blit(self.hud, (0,self.height))

    def tickHUD(self,screen,timestamp):
        self.hud.blit(self.hudBg,(0,0))

        # killCount
        self.killstr = ""
        if(self.kills < 10):
            self.killstr = "slain: 0" + str(self.kills)
        else:
            self.killstr = "slain: " + str(self.kills)
        screen.blit(self.counterFont.render(self.killstr, True, (240, 240, 255)),(screen.get_width()-190,10))
        #lives
        self.drawHealthBar(self.hud)


        # CD Icon Q
        cdq = (self.cooldownQ*1000 - (timestamp-self.timeUsedQ))/1000
        if cdq <= 0:

            screen.blit(self.iconQ, (20,20))
        else:
            screen.blit(self.iconQBW, (20,20))
        screen.blit(self.counterFont.render("Q", True, (240, 240, 255)),(20, 50))
        screen.blit(self.cdFont.render(str(max(cdq,0)), True, (240, 240, 255)), (50, 20))

        # CD Icon W
        cdw = (self.cooldownW*1000 - (timestamp-self.timeUsedW))/1000
        if(cdw <= 0):
            screen.blit(self.iconW, (110,20))
        else:
            screen.blit(self.iconWBW, (110,20))
        screen.blit(self.counterFont.render("W", True, (240, 240, 255)),(110, 50))
        screen.blit(self.cdFont.render(str(max(cdw,0)), True, (240, 240, 255)), (140, 20))
        
        #cooldown icon E
        cde = (self.cooldownE*1000 - (timestamp-self.timeUsedE))/1000
        if cde <= 0:
            screen.blit(self.iconE, (200,20))
        else:
            screen.blit(self.iconEBW, (200,20))
        screen.blit(self.counterFont.render("E", True, (240, 240, 255)),(200, 50))
        screen.blit(self.cdFont.render(str(max(cde,0)), True, (240, 240, 255)), (230, 20))

        #cooldown icon R
        cdr = (self.cooldownR*1000 - (timestamp-self.timeUsedR))/1000
        if cdr <= 0:
            screen.blit(self.iconR, (290,20))
        else:
            screen.blit(self.iconRBW, (290,20))
        screen.blit(self.counterFont.render("R", True, (240, 240, 255)),(290, 50))
        screen.blit(self.cdFont.render(str(max(cdr,0)), True, (240, 240, 255)), (320, 20))
        self.drawHud()



    def loop(self):
        time_passed = self.clock.tick(self.fps) / 1000.0
        playerPos = (self.player.rect.left + self.player.rect.width / 2, self.player.rect.top)

        #global time
        timestamp = pygame.time.get_ticks()

        for event in pygame.event.get():
            if event.type == QUIT:
                exit()
            # other keys
            elif event.type == KEYUP:
                # Binding Bomb
                if event.key == K_q:
                    if(timestamp - self.timeUsedQ >= BindBomb.cooldown * 1000):
                        bomb = BindBomb(playerPos,self.soundQ,self.soundQHit)
                        self.timeUsedQ = timestamp
                        self.bombs.add(bomb)
                # Minebomb
                elif event.key == K_e:
                    bomb = MineBomb(pygame.mouse.get_pos(),self.soundE,self.soundEHit)
                    # das mache ich, weil der sound bei initialisierung der MineBomb gestartet wird,
                    # aber ich dieses Bomb Objekt brauche um darauf zu pruefen ob bereits eine liegt:
                    self.soundE.stop()
                    minebombs = self.bombsContainType(bomb)
                    if(len(minebombs) > 0):
                        for mine in minebombs:
                            mine.activate(timestamp)
                    else:
                        if(timestamp - self.timeUsedE >= MineBomb.cooldown * 1000):
                            self.timeUsedE = timestamp
                            self.bombs.add(bomb)
                            self.soundE.play(-1)
                # Laserbomb
                elif event.key == K_r:
                    if(timestamp - self.timeUsedR >= LaserBomb.cooldown * 1000):
                        bomb = LaserBomb(playerPos, timestamp,self.soundR)
                        # @type clock
                        self.timeUsedR = timestamp
                        self.bombs.add(bomb)
                elif event.key == K_SPACE or event.key == K_w:
                    if(timestamp - self.timeUsedW >= BombSprite.cooldown * 1000):
                        bomb = BombSprite(playerPos,self.soundW,self.soundWHit)
                        self.timeUsedW = timestamp
                        self.bombs.add(bomb)
                    if self.gameover:
                        self.initGame()



        if(not self.gameover):
            self.screen.blit(pygame.image.load(self.bgImage), (0, 0))



            #update and draw en emies
            self.enemies.update(timestamp, self.width, time_passed)
            self.enemies.draw(self.screen)
            if((timestamp -self.timeBonusSpawned+random.randint(-1000,1000)) > 10000):

                self.enemies.add(EnemySpriteTop((0,0),100,300,Rect(0,0,self.width,self.height)))
                print("bonus round!")
                self.timeBonusSpawned = timestamp

            for enemy in self.enemies:
                if(random.randint(0,3000) == 1000):
                    self.enemyBombs.add(EnemyBomb((enemy.rect.left,enemy.rect.top),self.soundW,self.soundWHit))
                if(type(enemy) is not EnemySpriteTop):
                    if enemy.reachedBottom:
                        print("enemy reached bottom!");
                        enemy.kill()
                        self.player.lives = 0
                    if(enemy.rect.right > enemy.boundaries.right and not enemy.hp < 0):
                        enemy.rect.right = enemy.boundaries.right
                        print("touched right side")
                        print(enemy.rect.right)

                        for enemy2 in self.enemies:
                            if type(enemy2) is not EnemySpriteTop:
                                print(type(enemy))
                                enemy2.direction *= -1
                                enemy2.rect.top += enemy2.image.get_height()
                                enemy2.speed = enemy2.speed + 1
                                enemy2.oldSpeed = enemy2.speed
                        break
                    elif(enemy.rect.left < enemy.boundaries.left and not enemy.hp < 0):
                        enemy.rect.left = enemy.boundaries.left
                        for enemy2 in self.enemies:
                            if type(enemy2) is not EnemySpriteTop:
                                enemy2.direction *= -1
                                enemy2.rect.top += enemy2.image.get_height()
                                enemy2.speed = enemy2.speed + 1
                                enemy2.oldSpeed = enemy2.speed
                        break


            #update and draw bombs
            self.enemyBombs.update(timestamp, time_passed)
            self.enemyBombs.draw(self.screen)

            #self.blocks.update()
            self.blocks.draw(self.screen)

            #update and draw bombs
            self.bombs.update(timestamp, time_passed)
            self.bombs.draw(self.screen)

            # collision
            pygame.sprite.groupcollide(self.bombs, self.enemies, False, False, self.testCollision)
            pygame.sprite.groupcollide(self.enemyBombs, self.playerG, True, False, self.testCollision)

            pygame.sprite.groupcollide(self.bombs, self.blocks, True, True)
            pygame.sprite.groupcollide(self.enemyBombs, self.blocks, True, True)

            # update and draw player
            self.player.update(self.width, time_passed, pygame.key.get_pressed())
            self.screen.blit(self.player.image, self.player.rect)

            # draw UI
            self.tickHUD(self.hud,timestamp)

            # new wave
            if(len(self.enemies) <= 0):
                #self.enemyCount += self.enemyCountIncrease
                self.enemyInitialSpeed += self.enemySpeedIncrease
                self.enemyHealth += self.enemyHealthIncrease
                self.createEnemies(self.enemyCount[0],self.enemyCount[1], self.enemyInitialSpeed,self.enemyHealth)

            if self.player.lives <= 0:
                self.gameover = True;
                self.showEnd()

        pygame.display.update()

    def drawHealthBar(self,screen):
            pygame.draw.rect(self.iconLives,(255,0,0),(0,0,180,30))
            pygame.draw.rect(self.iconLives,(0,255,0),(0,0, ceil(180.0 * (float(self.player.lives)/float(self.player.maxLives))) ,30))
            screen.blit(self.iconLives,(self.width-190, 50))
		
if __name__ == "__main__":
	Game(30)
