import pygame
from pygame import *
import math


__author__="mg"
__date__ ="$May 27, 2013 1:01:03 PM$"

class LaserBomb(pygame.sprite.Sprite):
    cooldown = 10.0

    def __init__(self, initial_position,timestamp,sound):
        pygame.sprite.Sprite.__init__(self)
        self.laserImage = pygame.image.load("img/LaserBomb.png").convert_alpha()
        self.image = pygame.Surface((2,2))
        self.soundStart = sound

        self.initialPosition = initial_position
        self.rect = self.image.get_rect()
        self.rect.bottomleft = (self.initialPosition[0]-self.image.get_width()/2, self.initialPosition[1])

        self.activated = timestamp
        self.width = 100
        self.speed = 1000
        self.damage = 200
        self.soundStart.play(0)

    # hit(Sprite Enemy, timestamp )
    # Funktion wird aufgerufen sobald das Projektil einen Gegner trifft. Dieser wird bergeben
    # ret bool ob der Treffer den Gegner toetet
    def hit(self,enemy,timestamp):
        if self not in enemy.hitBy:
            enemy.hitWith({self:timestamp})
            killed = enemy.dealDamage(self.damage)
            return killed
        return False



    def update(self,timestamp,time_passed):
        lifeTime = timestamp - self.activated
        if(lifeTime < 1000):
            pass
        elif(lifeTime < 1800):
            self.image = self.laserImage
            self.rect = self.image.get_rect()
            self.rect.bottomleft = (self.initialPosition[0]-self.image.get_width()/2, self.initialPosition[1])

        else:
            self.kill()


