import pygame
import math


__author__="mg"
__date__ ="$May 27, 2013 1:01:03 PM$"

class MineBomb(pygame.sprite.Sprite):
    cooldown=5.0
    def __init__(self,initial_position,soundStart,soundHit):
        pygame.sprite.Sprite.__init__(self)
        self.soundStart = soundStart
        self.soundHit = soundHit
        self.image = pygame.image.load("img/MineBomb.png").convert_alpha()
        self.rect = self.image.get_rect()
        self.rect.topleft = (initial_position[0] - self.image.get_width()/2, initial_position[1] - self.image.get_height()/2)
        self.speed = 600
        self.damage = 90
        self.slowAmount=0.5
        self.slowTime = 0.1
        self.active = False
        self.activated = 0

        self.soundStart.play(-1)

    # hit(Sprite Enemy, timestamp )
    # Funktion wird aufgerufen sobald das Projektil einen Gegner trifft. Dieser wird bergeben
    # ret bool ob der Treffer den Gegner toetet
    def hit(self,enemy,timestamp):
        if(self.active):
            if(self not in enemy.hitBy):
                enemy.hitWith({self:timestamp})
                killed = enemy.dealDamage(self.damage)
                self.soundStart.stop()
                self.soundHit.play()
                self.kill()
                return killed
        else:
            enemy.disable({"slow":(pygame.time.get_ticks(), self.slowTime, self.slowAmount)})
        return False;

    def activate(self,timestamp):

        self.active= True
        self.activated = timestamp

    def update(self,timestamp,time_passed):


        if(self.active and timestamp - self.activated > 50):
            self.kill()
        else:
            pass




